import { Component, OnInit } from '@angular/core';
import { FormGroup, FormBuilder, Validators } from '@angular/forms';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})

export class AppComponent implements OnInit {
  title = 'Angular6 Reactive forms example';

  myForm: FormGroup;
  formData: any;
  countries = [];

  constructor(private fb: FormBuilder) {
    this.countries = [
      { 'id': 1, 'name': 'India', 'code': 'IN' },
      { 'id': 2, 'name': 'Nepal', 'code': 'NP' },
      { 'id': 3, 'name': 'United Kingdom', 'code': 'GB' },
      { 'id': 4, 'name': 'United States', 'code': 'US' },
    ];
  }

  _formValidate() {
    this.myForm = this.fb.group(
      {
        name: ['', Validators.compose([Validators.required, Validators.pattern('[a-zA-Z]+')])],
        email: ['', Validators.compose([Validators.required, Validators.email])],
        phone: ['', Validators.compose([Validators.required, Validators.pattern('[0-9]+')])],
        country: ['-1']
      }
    );
  }

  ngOnInit() {
    this._formValidate();
  }

  _formSubmit() {
    this.formData = this.myForm.getRawValue();
    console.log(this.formData);
  }
}
